Package: org.apache.groovy.ast.tools

## [Java] Class ImmutablePropertyUtils

- org.apache.groovy.ast.tools.ImmutablePropertyUtils

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static ClassNode` | `IMMUTABLE_OPTIONS_TYPE` |

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `static boolean` | `builtinOrMarkedImmutableClass(Class<?> clazz)`
    `` | `static Expression` | `cloneArrayOrCloneableExpr(Expression fieldExpr, ClassNode type)`
    `` | `static Expression` | `cloneDateExpr(Expression origDate)`
    `` | `static String` | `createErrorMessage(String className, String fieldName, String typeName, String mode)`
    `` | `static boolean` | `derivesFromDate(ClassNode fieldType)`
    `` | `static List<String>` | `getKnownImmutableClasses(AbstractASTTransformation xform, ClassNode cNode)`
    `` | `static List<String>` | `getKnownImmutables(AbstractASTTransformation xform, ClassNode cNode)`
    `` | `static boolean` | `implementsCloneable(ClassNode fieldType)`
    `` | `static boolean` | `isBuiltinImmutable(String typeName)`
    `` | `static boolean` | `isKnownImmutableType(ClassNode fieldType, List<String> knownImmutableClasses)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Field Detail

    - #### public static final ClassNode IMMUTABLE_OPTIONS_TYPE

  - ### Method Detail

    - #### public static boolean builtinOrMarkedImmutableClass(Class<?> clazz)

    - #### public static Expression cloneArrayOrCloneableExpr(Expression fieldExpr, ClassNode type)

    - #### public static Expression cloneDateExpr(Expression origDate)

    - #### public static String createErrorMessage(String className, String fieldName, String typeName, String mode)

    - #### public static boolean derivesFromDate(ClassNode fieldType)

    - #### public static List<String> getKnownImmutableClasses(AbstractASTTransformation xform, ClassNode cNode)

    - #### public static List<String> getKnownImmutables(AbstractASTTransformation xform, ClassNode cNode)

    - #### public static boolean implementsCloneable(ClassNode fieldType)

    - #### public static boolean isBuiltinImmutable(String typeName)

    - #### public static boolean isKnownImmutableType(ClassNode fieldType, List<String> knownImmutableClasses)